using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace GetTheHeightOfTheTerrainModel
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;


        // n`f̐錾
        private Model map;
        // R[f̐錾
        private Model cone;

        // n`f̃XP[̐錾
        private float mapScale;

        // R[̍W̐錾
        private Vector3[] conePos;

        // s̐錾
        private Matrix mapWorld;
        private Matrix coneWorld;
        private Matrix view;
        private Matrix projection;
        
        // NX̐錾
        private HeightInfo heightInfo;



        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            // R[W̏ݒ
            conePos = new Vector3[5]
                {
                    new Vector3(-37, 0, -54),
                    new Vector3(-28, 0, -49),
                    new Vector3(-24, 0, -40),
                    new Vector3(-19, 0, -29),
                    new Vector3(-14, 0, -20)
                };

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here

            // n`f̃XP[
            this.mapScale = 50.0f;
            // n`̃[hWϊs
            this.mapWorld = Matrix.CreateScale(new Vector3(mapScale, mapScale, mapScale));

            // r[Wϊs
            this.view = Matrix.CreateLookAt(
                new Vector3(-30, 30, 10),
                new Vector3(-25, 0, -40),
                Vector3.Up);

            // ˉeϊs
            this.projection = Matrix.CreatePerspectiveFieldOfView(
                MathHelper.ToRadians(45.0f),            // p
                this.GraphicsDevice.Viewport.Width /
                this.GraphicsDevice.Viewport.Height,    // AXyNg
                1f,                                     // ߃Nbv
                1000.0f                                 // Nbv
            );


            // ff[^Ăяo
            this.cone = Content.Load<Model>("Cone001");
            this.map = Content.Load<Model>("MainMap");

            //// NX̐錾
            this.heightInfo = new HeightInfo(map, mapScale);
        }


        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here

            // n``
            drawModel(map, mapWorld);

            // R[`
            foreach (Vector3 pos in conePos)
            {
                // R[XWZWݒ肷
                Vector3 newPos = pos;
                // R[YWin`̍j擾
                newPos.Y = heightInfo.GetHeight(pos);
                // R[̃[hWϊs
                this.coneWorld = Matrix.CreateTranslation(newPos); // ړ
                // R[`
                drawModel(cone, coneWorld);
            }

            base.Draw(gameTime);
        }


        // f`
        private void drawModel(Model model, Matrix world)
        {
            foreach (ModelMesh mesh in model.Meshes)
            {
                foreach (BasicEffect basicEffect in mesh.Effects)
                {
                    // ftHg̃CgLɂ
                    basicEffect.EnableDefaultLighting();

                    // [hWϊs
                    basicEffect.World = world;
                    // r[Wϊs
                    basicEffect.View = view;
                    // Ήeϊs
                    basicEffect.Projection = projection;
                }
                // bV`
                mesh.Draw();
            }
        }
    }
}
